<template>
  <div>
    <AtomAlert
      v-if="error"
      class="fr-mx-4w"
      :alert-type="AlertType.Error"
      message="La liste des instructions de demande d'aide n'a pas pu être chargée."
    />
    <template v-else>
      <BeneficiaryHistoryFilters
        class="fr-px-5v"
        :is-in-interviews-context="false"
        :is-in-help-requests-context="true"
        @filter="onFilter"
      />
      <hr />
      <p class="fr-mb-2w fr-mx-5v fr-hint-text">
        {{ helpRequestsCount }} instructions(s) de demande d'aide
      </p>
      <AtomLoader
        v-show="pending"
        class="fr-mx-auto"
      />
      <div
        class="table-container fr-pb-0"
        tabindex="0"
      >
        <div
          v-show="!pending"
          class="fr-table fr-table--bordered fr-mb-0 fr-pt-0 fr-table--no-caption"
        >
          <table>
            <caption>
              Instructions
            </caption>
            <thead>
              <tr>
                <th
                  id="status-col"
                  scope="col"
                >
                  Statut
                </th>
                <th scope="col">Objet de la demande</th>
                <th
                  v-if="canAccessRestrictedFieldsInHelpRequest"
                  scope="col"
                >
                  Date d'échéance
                  <AtomSortButton @sort="onSort($event, 'due_date')" />
                </th>
                <th scope="col">
                  Bénéficiaire
                  <AtomSortButton
                    @sort="onSort($event, 'beneficiary.usual_name')"
                  />
                </th>
                <template v-if="canAccessRestrictedFieldsInHelpRequest">
                  <th scope="col">
                    Organisme instructeur
                    <AtomSortButton
                      @sort="onSort($event, 'organisme_instructeur.name')"
                    />
                  </th>
                  <th scope="col">Date de passage en commission</th>
                  <th scope="col">Montant demandé</th>
                  <th
                    id="allocated-amount-col"
                    scope="col"
                  >
                    Montant attribué
                  </th>
                  <th
                    id="payment-method-col"
                    scope="col"
                  >
                    Mode de paiement
                  </th>
                  <th
                    id="payment-date-col"
                    scope="col"
                  >
                    Date du paiement
                  </th>
                  <th scope="col">Date de fin de prise en charge</th>
                </template>
                <th scope="col">Agent</th>
                <th scope="col">N° de dossier</th>
              </tr>
            </thead>
            <tbody>
              <BeneficiaryHistoryRow
                v-for="helpRequest in helpRequests"
                :key="helpRequest.id"
                :history="helpRequest"
                @updated="onHelpRequestUpdated"
              />
            </tbody>
          </table>
        </div>
      </div>
      <AtomPagination
        v-show="!pending"
        class="fr-mt-4w fr-px-5v"
        :page="page"
        :total="helpRequestsCount"
        @change-page="updatePagination($event)"
      />
    </template>
  </div>
</template>

<script setup>
  import { REQUEST_LIMIT_DEFAULT } from '~/utils/constants'
  import { errorResponseMessage } from '~/utils/errorResponse'
  import { getRandomId } from '~~/utils/random'
  import { AlertType } from '~~/utils/constants/alert'
  import { useFiltersStore } from '~/store/filters'
  import { usePermissionsStore } from '~/store/permissions'

  const DEFAULT_SORT = { field: 'opening_date', sort: '-' }

  const permissionsStore = usePermissionsStore()
  const filtersStore = useFiltersStore()
  const { $getItems } = useNuxtApp()

  const filters = ref(
    filtersStore.helpRequestHistory.directusQuery?.helpRequestFilters
  )
  const sorts = ref([DEFAULT_SORT])
  const page = ref(1)
  const limit = ref(REQUEST_LIMIT_DEFAULT)

  const {
    data: helpRequests,
    pending: helpRequestsPending,
    error: helpRequestsError,
    refresh: helpRequestsRefresh
  } = useLazyAsyncData(getRandomId('helpRequests'), loadHelpRequests, {
    server: false
  })

  const {
    data: helpRequestsCount,
    pending: helpRequestsCountPending,
    error: helpRequestsCountError,
    refresh: helpRequestsCountRefresh
  } = useLazyAsyncData(
    getRandomId('helpRequestsCount'),
    loadHelpRequestsCount,
    {
      server: false,
      default: () => 0
    }
  )

  const canAccessRestrictedFieldsInHelpRequest = computed(
    () => permissionsStore.canAccessRestrictedFieldsInHelpRequest
  )

  const pending = computed(
    () => helpRequestsPending.value || helpRequestsCountPending.value
  )

  const error = computed(
    () => helpRequestsError.value || helpRequestsCountError.value
  )

  async function loadHelpRequests() {
    const fields = permissionsStore.accessibleHelpRequestFields

    const query = {
      fields,
      sort: sorts.value,
      limit: limit.value,
      page: page.value
    }

    if (filters.value) query.filter = filters.value

    const res = await $getItems('help_requests', query)

    if (res.status === 200) return res.data.data
    throw new Error(errorResponseMessage(res))
  }

  // NOTE: It is not using `filter_count` meta in the query loading the items due to a Directus bug - See https://github.com/directus/directus/discussions/16992
  async function loadHelpRequestsCount() {
    const query = { aggregate: { countDistinct: 'id' } }
    if (filters.value) query.filter = filters.value

    const res = await $getItems('help_requests', query)

    if (res.status === 200) return parseInt(res.data.data[0].countDistinct.id)
    throw new Error(errorResponseMessage(res))
  }

  function onFilter({ helpRequestFilters }) {
    filters.value = helpRequestFilters
    helpRequestsRefresh()
    helpRequestsCountRefresh()
  }

  function onSort(sortDir, field) {
    sorts.value = sorts.value.filter(s => s.field !== field)
    sorts.value.unshift({ field, sort: sortDir })
    helpRequestsRefresh()
  }

  function updatePagination({ pageNumber, limitValue }) {
    page.value = pageNumber
    limit.value = Number(limitValue)
    helpRequestsRefresh()
  }

  function onHelpRequestUpdated(helpRequest) {
    helpRequests.value = helpRequests.value.map(h =>
      h.id === helpRequest.id ? helpRequest : h
    )
  }
</script>

<style lang="scss" scoped>
  .table-container {
    // 21.5rem seems to come up out of the box. It corresponds to the total height of elements existing above and under the table
    max-height: calc(100vh - 23.5rem);
  }
</style>
